'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactstrap = require('reactstrap');

var _lodash = require('lodash.range');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Paginator = function Paginator(_ref) {
  var numPages = _ref.numPages,
      currentPage = _ref.currentPage,
      goToPage = _ref.goToPage,
      _ref$className = _ref.className,
      className = _ref$className === undefined ? 'justify-content-center' : _ref$className;
  return _react2.default.createElement(
    _reactstrap.Pagination,
    { className: className },
    _react2.default.createElement(
      _reactstrap.PaginationItem,
      { disabled: !currentPage || currentPage === 1 },
      _react2.default.createElement(_reactstrap.PaginationLink, { previous: true, onClick: function onClick() {
          return goToPage(currentPage - 1);
        } })
    ),
    (0, _lodash2.default)(numPages).map(function (page) {
      return _react2.default.createElement(
        _reactstrap.PaginationItem,
        { key: page, active: page + 1 === currentPage },
        _react2.default.createElement(
          _reactstrap.PaginationLink,
          { onClick: function onClick() {
              return goToPage(page + 1);
            } },
          page + 1
        )
      );
    }),
    _react2.default.createElement(
      _reactstrap.PaginationItem,
      { disabled: !currentPage || !(currentPage < numPages) },
      _react2.default.createElement(_reactstrap.PaginationLink, { next: true, onClick: function onClick() {
          return goToPage(currentPage + 1);
        } })
    )
  );
};

exports.default = Paginator;