'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PropertiesGrid = function (_PureComponent) {
  _inherits(PropertiesGrid, _PureComponent);

  function PropertiesGrid() {
    _classCallCheck(this, PropertiesGrid);

    return _possibleConstructorReturn(this, (PropertiesGrid.__proto__ || Object.getPrototypeOf(PropertiesGrid)).apply(this, arguments));
  }

  _createClass(PropertiesGrid, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          list = _props.list,
          breakpoint = _props.breakpoint,
          className = _props.className,
          labelClass = _props.labelClass,
          valueClass = _props.valueClass,
          equalColumn = _props.equalColumn;

      var nested = list.length && Array.isArray(list[0]);

      return _react2.default.createElement(
        'div',
        { className: className },
        !nested ? _react2.default.createElement(
          'ul',
          { className: 'list-group' },
          list && list.map(function (item, i) {
            return _react2.default.createElement(
              'li',
              { className: 'list-group-item', key: i },
              _react2.default.createElement(
                'div',
                { className: 'w-100 d-inline-flex justify-content-between' },
                _react2.default.createElement(
                  'span',
                  { className: labelClass },
                  item.label
                ),
                _react2.default.createElement(
                  'span',
                  { className: valueClass },
                  item.value
                )
              )
            );
          })
        ) : _react2.default.createElement(
          'div',
          { className: 'row ml-0 mr-0' },
          list && list.map(function (l, i) {
            return _react2.default.createElement(
              'ul',
              {
                key: i,
                className: 'col' + (equalColumn ? '-md-' + 12 / list.length + ' col-sm-12' : '') + ' list-group mb-3 mb-' + breakpoint + '-0'
              },
              l.map(function (item, i) {
                return _react2.default.createElement(
                  'li',
                  { className: 'list-group-item', key: i },
                  _react2.default.createElement(
                    'div',
                    {
                      className: 'w-100 d-flex justify-content-between flex-column flex-' + breakpoint + '-row'
                    },
                    _react2.default.createElement(
                      'span',
                      { className: labelClass },
                      item.label
                    ),
                    _react2.default.createElement(
                      'span',
                      { className: valueClass },
                      item.value
                    )
                  )
                );
              })
            );
          })
        )
      );
    }
  }]);

  return PropertiesGrid;
}(_react.PureComponent);

PropertiesGrid.defaultProps = {
  breakpoint: 'sm'
};

exports.default = PropertiesGrid;