'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('match-media');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _reactJss = require('react-jss');

var _reactJss2 = _interopRequireDefault(_reactJss);

var _consts = require('../consts');

var _TopbarStyles = require('./TopbarStyles');

var _TopbarStyles2 = _interopRequireDefault(_TopbarStyles);

var _TopBarLink = require('./TopBarLink');

var _TopBarLink2 = _interopRequireDefault(_TopBarLink);

var _PaddedList = require('./PaddedList');

var _PaddedList2 = _interopRequireDefault(_PaddedList);

var _TogglerButton = require('./TogglerButton');

var _TogglerButton2 = _interopRequireDefault(_TogglerButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Topbar = function (_PureComponent) {
  _inherits(Topbar, _PureComponent);

  function Topbar() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Topbar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Topbar.__proto__ || Object.getPrototypeOf(Topbar)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      open: false,
      showOffCanvas: false
    }, _this.updateOffCanvas = function () {
      var breakpoint = _this.props.breakpoint;

      var showOffCanvas = false;
      if (window.matchMedia('only screen and (' + _consts.breakpoints[breakpoint] + ')').matches) {
        showOffCanvas = true;
      }

      if (_this.state.showOffCanvas !== showOffCanvas) {
        _this.setState({ showOffCanvas: showOffCanvas });
      }
    }, _this.toggleMenu = function () {
      _this.setState({
        open: !_this.state.open
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Topbar, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.updateOffCanvas();
      window.addEventListener('resize', this.updateOffCanvas, false);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.updateOffCanvas);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(oldProps) {
      if (oldProps.breakpoint !== this.props.breakpoint) {
        this.updateOffCanvas();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          navbarClass = _props.navbarClass,
          brand = _props.brand,
          rightLinks = _props.rightLinks,
          leftLinks = _props.leftLinks,
          togglerPosition = _props.togglerPosition,
          togglerClassName = _props.togglerClassName,
          offCanvasItemClass = _props.offCanvasItemClass,
          offCanvasPosition = _props.offCanvasPosition,
          offCanvasMenuOpenClass = _props.offCanvasMenuOpenClass,
          offCanvasMenuClosedClass = _props.offCanvasMenuClosedClass;


      var offCanvasPosClass = '';
      if (offCanvasPosition === 'right') {
        offCanvasPosClass = classes.right0;
      } else if (offCanvasPosition === 'left') {
        offCanvasPosClass = classes.left0;
      }

      var showOffCanvas = this.state.showOffCanvas;


      return _react2.default.createElement(
        'div',
        { className: 'navbar navbar-expand w-100 ' + classes.navH + ' ' + navbarClass },
        showOffCanvas && togglerPosition === 'left' && _react2.default.createElement(_TogglerButton2.default, {
          openIconClass: offCanvasMenuOpenClass,
          closedIconClass: offCanvasMenuClosedClass,
          className: togglerClassName,
          onClick: this.toggleMenu,
          open: this.state.open
        }),
        _react2.default.createElement(
          'span',
          { className: 'navbar-brand' },
          brand
        ),
        _react2.default.createElement(
          'ul',
          { className: 'navbar-nav mr-auto' },
          !showOffCanvas && leftLinks.map(function (linkConf, i) {
            return _react2.default.createElement(_TopBarLink2.default, _extends({ key: i }, linkConf));
          })
        ),
        _react2.default.createElement(
          'ul',
          { className: 'navbar-nav' },
          !showOffCanvas && rightLinks.map(function (linkConf, i) {
            return _react2.default.createElement(_TopBarLink2.default, _extends({ key: i }, linkConf));
          })
        ),
        showOffCanvas && togglerPosition === 'right' && _react2.default.createElement(_TogglerButton2.default, {
          openIconClass: offCanvasMenuOpenClass,
          closedIconClass: offCanvasMenuClosedClass,
          className: togglerClassName,
          onClick: this.toggleMenu,
          open: this.state.open
        }),
        showOffCanvas && this.state.open && _react2.default.createElement(
          'div',
          {
            className: 'Topbar__offCanvas ' + classes.offCanvas + ' ' + offCanvasPosClass + ' ' + navbarClass
          },
          _react2.default.createElement(
            'ul',
            { className: 'list-group w-100' },
            leftLinks.concat(rightLinks).map(function (l, i) {
              return l.links ? _react2.default.createElement(_PaddedList2.default, { label: l.label, items: l.links, className: offCanvasItemClass, key: i }) : _react2.default.createElement(
                'li',
                { onClick: l.onClick, className: 'list-group-item ' + offCanvasItemClass, key: i },
                l.to ? _react2.default.createElement(
                  _reactRouterDom.NavLink,
                  { to: l.to },
                  l.label
                ) : l.label
              );
            })
          )
        )
      );
    }
  }]);

  return Topbar;
}(_react.PureComponent);

Topbar.defaultProps = {
  breakpoint: 'xs',
  leftLinks: [],
  rightLinks: [],
  togglerPosition: 'left',
  togglerClassName: 'text-white',
  offCanvasPosition: 'left',
  offCanvasItemClass: 'bg-dark',
  offCanvasMenuOpenClass: 'fa fa-times',
  offCanvasMenuClosedClass: 'fa fa-bars',
  navbarClass: 'navbar-dark bg-dark text-white'
};

exports.default = (0, _reactJss2.default)(_TopbarStyles2.default)(Topbar);