'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = withDataTable;

var _react = require('react');

var _lodash = require('lodash.defaults');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.debounce');

var _lodash4 = _interopRequireDefault(_lodash3);

var _queryString = require('query-string');

var _queryString2 = _interopRequireDefault(_queryString);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function withDataTable() {
  var c = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};


  var config = _extends({
    filters: [],
    queryString: true
  }, c);

  var defaultFilters = config.filters.reduce(function (d, f) {
    return _extends({}, d, _defineProperty({}, f, ''));
  }, {});

  return function wrapWithDataTable(WrappedComponent) {
    var DataTable = function (_PureComponent) {
      _inherits(DataTable, _PureComponent);

      function DataTable(props) {
        _classCallCheck(this, DataTable);

        // Use React state as source of truth otherwise use query string!
        var _this = _possibleConstructorReturn(this, (DataTable.__proto__ || Object.getPrototypeOf(DataTable)).call(this, props));

        _this.getParams = function () {
          var defaultParams = _extends({}, defaultFilters, {
            page: 1
          });
          var baseParams = config.queryString ? _queryString2.default.parse(_this.props.location.search) : _this.state.params;

          return (0, _lodash2.default)(baseParams, defaultParams);
        };

        _this.updateParam = function (name, value) {
          var debounced = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
          var location = _this.props.location;

          var currentParams = config.queryString ? _queryString2.default.parse(_queryString2.default.extract(location.search)) : _this.state.params;

          var nextParams = _extends({}, currentParams, _defineProperty({
            // Reset page ... until name is page eheh
            page: 1
          }, name, value));

          if (config.queryString) {
            _this.props.history.push(location.pathname + '?' + _queryString2.default.stringify(nextParams));
          } else {
            _this.setState({ params: nextParams });
          }

          if (debounced) {
            _this.loadItemsDebounced(nextParams);
          } else {
            _this.props.loadItems(nextParams);
          }
        };

        _this.reload = function () {
          return _this.props.loadItems(_this.getParams());
        };

        _this.loadItemsDebounced = (0, _lodash4.default)(_this.props.loadItems, 150);

        _this.goToPage = function (page) {
          return _this.updateParam('page', page);
        };

        _this.makeFiltersProp = function () {
          var params = _this.getParams();
          return config.filters.reduce(function (r, f) {
            var value = params[f];
            var onChange = function onChange(e) {
              var value = e;
              if (e && e.target && e.target instanceof Element) {
                value = e.target.value;
              }
              _this.updateParam(f, value, true);
            };

            return _extends({}, r, _defineProperty({}, f, {
              value: value,
              onChange: onChange
            }));
          }, {});
        };

        if (!config.queryString) {
          _this.state = {
            params: _extends({}, defaultFilters, {
              page: 1
            })
          };
        }
        return _this;
      }

      _createClass(DataTable, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          this.props.loadItems(this.getParams());
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          var unloadItems = this.props.unloadItems;

          if (typeof unloadItems === 'function') {
            unloadItems();
          }
        }
      }, {
        key: 'render',
        value: function render() {
          var _getParams = this.getParams(),
              page = _getParams.page;

          var filters = this.makeFiltersProp();

          return (0, _react.createElement)(WrappedComponent, _extends({}, this.props, {
            page: +page,
            filters: filters,
            reload: this.reload,
            goToPage: this.goToPage
          }));
        }
      }]);

      return DataTable;
    }(_react.PureComponent);

    return (0, _hoistNonReactStatics2.default)(DataTable, WrappedComponent);
  };
}